Debian Bug report logs - #418158
poisscdf fails for large arguments due to the algorithm in D9LGIT

version graph

Package: octave; Maintainer for octave is Debian Octave Group <pkg-octave-devel@lists.alioth.debian.org>; Source for octave is src:octave.

Reported by: Francesco Potorti` <Potorti@isti.cnr.it>

Date: Sat, 7 Apr 2007 12:54:02 UTC

Severity: normal

Tags: upstream, wontfix

Merged with 493869

Found in version octave/3.6.1-4

Forwarded to https://savannah.gnu.org/bugs/index.php?39309

Reply or subscribe to this bug.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Francesco Potorti` <pot@potorti.it>, Debian Octave Group <pkg-octave-devel@lists.alioth.debian.org>:
Bug#418158; Package octave2.9. Full text and rfc822 format available.

Acknowledgement sent to Francesco Potorti` <Potorti@isti.cnr.it>:
New Bug report received and forwarded. Copy sent to Francesco Potorti` <pot@potorti.it>, Debian Octave Group <pkg-octave-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Francesco Potorti` <Potorti@isti.cnr.it>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: octave2.9: poissinv error
Date: Sat, 07 Apr 2007 14:42:20 +0200
Package: octave2.9
Version: 2.9.9-8etch1
Severity: normal

octave:70> poisscdf(10,10)
ans =  0.58304
octave:71> poissinv(10,10)
ans = NaN

The above should be an error.  Additionally, poisscdf(x,x) works for
x=100, but does not for x=1000:

octave:72> poisscdf(1000,1000)
 ***MESSAGE FROM ROUTINE D9LGIT IN LIBRARY SLATEC.
 ***FATAL ERROR, PROG ABORTED, TRACEBACK REQUESTED
 *  NO CONVERGENCE IN 200 TERMS OF CONTINUED FRACTION
 *  ERROR NUMBER = 3
 *   
 ***END OF MESSAGE
 
 ***JOB ABORT DUE TO FATAL ERROR.
0          ERROR MESSAGE SUMMARY
 LIBRARY    SUBROUTINE MESSAGE START             NERR     LEVEL     COUNT
 SLATEC     D9LGIT     NO CONVERGENCE IN 20         3         2         1

error: exception encountered in Fortran subroutine xgammainc_
error: in /usr/share/octave/2.9.9/m/statistics/distributions/poisscdf.m near line 58, column 14:

>>> cdf (k) = 1 - gammainc (l, floor (x (k)) + 1);

-- System Information:
Debian Release: 4.0
  APT prefers testing
  APT policy: (990, 'testing'), (500, 'testing-proposed-updates')
Architecture: amd64 (x86_64)
Shell:  /bin/sh linked to /bin/bash
Kernel: Linux 2.6.18-3-amd64
Locale: LANG=C, LC_CTYPE=it_IT@euro (charmap=ANSI_X3.4-1968) (ignored: LC_ALL set to C)

Versions of packages octave2.9 depends on:
ii  atlas3-base [liblapack.s 3.6.0-20.6      Automatically Tuned Linear Algebra
ii  fftw3                    3.1.2-1         library for computing Fast Fourier
ii  lapack3 [liblapack.so.3] 3.0.20000531a-6 library of linear algebra routines
ii  libc6                    2.3.6.ds1-13    GNU C Library: Shared libraries
ii  libgcc1                  1:4.1.1-21      GCC support library
ii  libgfortran1             4.1.1-21        Runtime library for GNU Fortran ap
ii  libglpk0                 4.11-2          linear programming kit (shared lib
ii  libhdf5-serial-1.6.5-0 [ 1.6.5-3         Hierarchical Data Format 5 (HDF5) 
ii  libncurses5              5.5-5           Shared libraries for terminal hand
ii  libpcre3                 6.7-1           Perl 5 Compatible Regular Expressi
ii  libreadline5             5.2-2           GNU readline and history libraries
ii  libstdc++6               4.1.1-21        The GNU Standard C++ Library v3
ii  libufsparse              1.2-7           collection of libraries for comput
ii  refblas3 [libblas.so.3]  1.2-8           Basic Linear Algebra Subroutines 3
ii  texinfo                  4.8.dfsg.1-4    Documentation system for on-line i
ii  zlib1g                   1:1.2.3-13      compression library - runtime

octave2.9 recommends no packages.

-- no debconf information



Reply sent to Rafael Laboissiere <rafael@debian.org>:
You have marked Bug as forwarded. Full text and rfc822 format available.

Message #8 received at 418158-forwarded@bugs.debian.org (full text, mbox):

From: Rafael Laboissiere <rafael@debian.org>
To: bug@octave.org
Cc: Francesco Potorti` <Potorti@isti.cnr.it>, 418158-forwarded@bugs.debian.org
Subject: [Potorti@isti.cnr.it: Bug#418158: octave2.9: poissinv error]
Date: Mon, 9 Apr 2007 21:24:12 +0200
package octave2.9
tags 418158 confirmed upstream
thanks

Below is a bug report filed against the octave2.9 package in Debian.  The
bug is also present in 2.9.10.

Thanks,

Rafael Labossiere


----- Forwarded message from Francesco Potorti` <Potorti@isti.cnr.it> -----

From: Francesco Potorti` <Potorti@isti.cnr.it>
Subject: [Pkg-octave-devel] Bug#418158: octave2.9: poissinv error
Date: Sat, 07 Apr 2007 14:42:20 +0200
To: Debian Bug Tracking System <submit@bugs.debian.org>
Reply-To: Francesco Potorti` <Potorti@isti.cnr.it>, 418158@bugs.debian.org
Organization: Debian GNU/Linux
Message-id: <E1HaAFI-00065p-Em@tucano.isti.cnr.it>

Package: octave2.9
Version: 2.9.9-8etch1
Severity: normal

octave:70> poisscdf(10,10)
ans =  0.58304
octave:71> poissinv(10,10)
ans = NaN

The above should be an error.  Additionally, poisscdf(x,x) works for
x=100, but does not for x=1000:

octave:72> poisscdf(1000,1000)
 ***MESSAGE FROM ROUTINE D9LGIT IN LIBRARY SLATEC.
 ***FATAL ERROR, PROG ABORTED, TRACEBACK REQUESTED
 *  NO CONVERGENCE IN 200 TERMS OF CONTINUED FRACTION
 *  ERROR NUMBER = 3
 *   
 ***END OF MESSAGE
 
 ***JOB ABORT DUE TO FATAL ERROR.
0          ERROR MESSAGE SUMMARY
 LIBRARY    SUBROUTINE MESSAGE START             NERR     LEVEL     COUNT
 SLATEC     D9LGIT     NO CONVERGENCE IN 20         3         2         1

error: exception encountered in Fortran subroutine xgammainc_
error: in /usr/share/octave/2.9.9/m/statistics/distributions/poisscdf.m near line 58, column 14:

>>> cdf (k) = 1 - gammainc (l, floor (x (k)) + 1);

-- System Information:
Debian Release: 4.0
  APT prefers testing
  APT policy: (990, 'testing'), (500, 'testing-proposed-updates')
Architecture: amd64 (x86_64)
Shell:  /bin/sh linked to /bin/bash
Kernel: Linux 2.6.18-3-amd64
Locale: LANG=C, LC_CTYPE=it_IT@euro (charmap=ANSI_X3.4-1968) (ignored: LC_ALL set to C)

Versions of packages octave2.9 depends on:
ii  atlas3-base [liblapack.s 3.6.0-20.6      Automatically Tuned Linear Algebra
ii  fftw3                    3.1.2-1         library for computing Fast Fourier
ii  lapack3 [liblapack.so.3] 3.0.20000531a-6 library of linear algebra routines
ii  libc6                    2.3.6.ds1-13    GNU C Library: Shared libraries
ii  libgcc1                  1:4.1.1-21      GCC support library
ii  libgfortran1             4.1.1-21        Runtime library for GNU Fortran ap
ii  libglpk0                 4.11-2          linear programming kit (shared lib
ii  libhdf5-serial-1.6.5-0 [ 1.6.5-3         Hierarchical Data Format 5 (HDF5) 
ii  libncurses5              5.5-5           Shared libraries for terminal hand
ii  libpcre3                 6.7-1           Perl 5 Compatible Regular Expressi
ii  libreadline5             5.2-2           GNU readline and history libraries
ii  libstdc++6               4.1.1-21        The GNU Standard C++ Library v3
ii  libufsparse              1.2-7           collection of libraries for comput
ii  refblas3 [libblas.so.3]  1.2-8           Basic Linear Algebra Subroutines 3
ii  texinfo                  4.8.dfsg.1-4    Documentation system for on-line i
ii  zlib1g                   1:1.2.3-13      compression library - runtime

octave2.9 recommends no packages.

-- no debconf information


----- End forwarded message -----



Message #9 received at 418158-forwarded@bugs.debian.org (full text, mbox):

From: "John W. Eaton" <jwe@bevo.che.wisc.edu>
To: Rafael Laboissiere <rafael@debian.org>
Cc: bug@octave.org, Francesco Potorti` <Potorti@isti.cnr.it>, 418158-forwarded@bugs.debian.org
Subject: [Potorti@isti.cnr.it: Bug#418158: octave2.9: poissinv error]
Date: Mon, 9 Apr 2007 16:33:31 -0400
On  9-Apr-2007, Rafael Laboissiere wrote:

| package octave2.9
| tags 418158 confirmed upstream
| thanks
| 
| Below is a bug report filed against the octave2.9 package in Debian.  The
| bug is also present in 2.9.10.
| 
| Thanks,
| 
| Rafael Labossiere
| 
| 
| ----- Forwarded message from Francesco Potorti` <Potorti@isti.cnr.it> -----
| 
| From: Francesco Potorti` <Potorti@isti.cnr.it>
| Subject: [Pkg-octave-devel] Bug#418158: octave2.9: poissinv error
| Date: Sat, 07 Apr 2007 14:42:20 +0200
| To: Debian Bug Tracking System <submit@bugs.debian.org>
| Reply-To: Francesco Potorti` <Potorti@isti.cnr.it>, 418158@bugs.debian.org
| Organization: Debian GNU/Linux
| Message-id: <E1HaAFI-00065p-Em@tucano.isti.cnr.it>
| 
| Package: octave2.9
| Version: 2.9.9-8etch1
| Severity: normal
| 
| octave:70> poisscdf(10,10)
| ans =  0.58304
| octave:71> poissinv(10,10)
| ans = NaN
| 
| The above should be an error.

Which of the above should be an error?  Why?

| Additionally, poisscdf(x,x) works for
| x=100, but does not for x=1000:
| 
| octave:72> poisscdf(1000,1000)
|  ***MESSAGE FROM ROUTINE D9LGIT IN LIBRARY SLATEC.
|  ***FATAL ERROR, PROG ABORTED, TRACEBACK REQUESTED
|  *  NO CONVERGENCE IN 200 TERMS OF CONTINUED FRACTION
|  *  ERROR NUMBER = 3
|  *   
|  ***END OF MESSAGE
|  
|  ***JOB ABORT DUE TO FATAL ERROR.
| 0          ERROR MESSAGE SUMMARY
|  LIBRARY    SUBROUTINE MESSAGE START             NERR     LEVEL     COUNT
|  SLATEC     D9LGIT     NO CONVERGENCE IN 20         3         2         1
| 
| error: exception encountered in Fortran subroutine xgammainc_
| error: in /usr/share/octave/2.9.9/m/statistics/distributions/poisscdf.m near line 58, column 14:
| 
| >>> cdf (k) = 1 - gammainc (l, floor (x (k)) + 1);

I don't plan to fix this problem myself, but would consier patches to
libcruft/slatec-fn/d9lgit.f or related subroutines.

jwe



Message #10 received at 418158-forwarded@bugs.debian.org (full text, mbox):

From: Francesco Potorti` <Potorti@isti.cnr.it>
To: "John W. Eaton" <jwe@bevo.che.wisc.edu>
Cc: 418158-forwarded@bugs.debian.org, bug@octave.org, Rafael Laboissiere <rafael@debian.org>
Subject: Re: [Potorti@isti.cnr.it: Bug#418158: octave2.9: poissinv error]
Date: Tue, 10 Apr 2007 00:17:02 +0200
>| octave:71> poissinv(10,10)
>| ans = NaN
>| The above should be an error.

Well, I was wrong, sorry.  In fact, I had not understood what the *inv
functions do.

>| octave:72> poisscdf(1000,1000)
>|  ***MESSAGE FROM ROUTINE D9LGIT IN LIBRARY SLATEC.
>|  ***FATAL ERROR, PROG ABORTED, TRACEBACK REQUESTED
>|  *  NO CONVERGENCE IN 200 TERMS OF CONTINUED FRACTION
>|  *  ERROR NUMBER = 3
>|  *   
>|  ***END OF MESSAGE
>|  
>|  ***JOB ABORT DUE TO FATAL ERROR.
>| 0          ERROR MESSAGE SUMMARY
>|  LIBRARY    SUBROUTINE MESSAGE START             NERR     LEVEL     COUNT
>|  SLATEC     D9LGIT     NO CONVERGENCE IN 20         3         2         1
>| 
>| error: exception encountered in Fortran subroutine xgammainc_
>| error: in /usr/share/octave/2.9.9/m/statistics/distributions/poisscdf.m near line 58, column 14:
>| 
>| >>> cdf (k) = 1 - gammainc (l, floor (x (k)) + 1);
>
>I don't plan to fix this problem myself, but would consier patches to
>libcruft/slatec-fn/d9lgit.f or related subroutines.

That would be a difficult job for me.  But if this bug gets registered
somewhere, maybe someone else will notice and correct it.

-- 
Francesco Potortì (ricercatore)        Voice: +39 050 315 3058 (op.2111)
ISTI - Area della ricerca CNR          Fax:   +39 050 315 2040
via G. Moruzzi 1, I-56124 Pisa         Email: Potorti@isti.cnr.it
Web: http://fly.isti.cnr.it/           Key:   fly.isti.cnr.it/public.key




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Octave Group <pkg-octave-devel@lists.alioth.debian.org>:
Bug#418158; Package octave2.9. Full text and rfc822 format available.

Acknowledgement sent to Rafael Laboissiere <rafael@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Octave Group <pkg-octave-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #15 received at 418158@bugs.debian.org (full text, mbox):

From: Rafael Laboissiere <rafael@debian.org>
To: control@bugs.debian.org
Cc: 418158@bugs.debian.org, 434415@bugs.debian.org
Subject: Forwarded bugs
Date: Tue, 24 Jul 2007 20:00:58 +0200
package octave2.9
forwarded 418158 http://www.cae.wisc.edu/pipermail/bug-octave/2007-April/002103.html
forwarded 434415 http://www.cae.wisc.edu/pipermail/octave-maintainers/2007-July/003530.html
thanks



Forwarded-to-address changed from bug@octave.org to http://www.cae.wisc.edu/pipermail/bug-octave/2007-April/002103.html. Request was from Rafael Laboissiere <rafael@debian.org> to control@bugs.debian.org. (Tue, 24 Jul 2007 18:03:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Octave Group <pkg-octave-devel@lists.alioth.debian.org>:
Bug#418158; Package octave2.9. Full text and rfc822 format available.

Acknowledgement sent to Rafael Laboissiere <rafael@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Octave Group <pkg-octave-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #22 received at 418158@bugs.debian.org (full text, mbox):

From: Rafael Laboissiere <rafael@debian.org>
To: control@bugs.debian.org
Cc: 420079@bugs.debian.org, 457541@bugs.debian.org, 435205@bugs.debian.org, 452560@bugs.debian.org, 435275@bugs.debian.org, 418158@bugs.debian.org, 434415@bugs.debian.org
Subject: Transferring bugs from octave2.9 to octave3.0
Date: Mon, 24 Dec 2007 15:03:22 +0100
package octave2.9

reassign 420079 octave3.0 3.0.0-1
retitle 420079 octave3.0 needs mkoctfiles

reassign 420080 octave3.0
retitle 420080 Merge octave3.0 and octave3.0-headers packages 

reassign 457541 octave3.0 3.0.0-1
retitle 457541 octave3.0: multiple assignment to a struct array

reassign 435205 octave2.1
retitle 435205 octave2.1: copyright file incorrectly lists GPLv2 only

reassign 452560 octave3.0 3.0.0-1
retitle 452560 octave3.0: behaviour of clear not entirely documented

reassign 435275 octave3.0-headers 3.0.0-1
retitle 435275 octave3.0-headers depends on gcc-3.4

reassign 418158 octave3.0 3.0.0-1
retitle 418158 octave3.0: poissinv error

reassign 434415 octave3.0-headers 3.0.0-1
retitle 434415 octave3.0-headers: Changed F77_FUNC_ macro

thanks


I am reassigning to octave3.0 all bug reports that were assigned to
octave2.9 (beside Bug#435205, which actually regards octave2.1).  The final
goal is to have octave2.9 clear for removal from the distribution.

-- 
Rafael




Bug reassigned from package `octave2.9' to `octave3.0'. Request was from Rafael Laboissiere <rafael@debian.org> to control@bugs.debian.org. (Mon, 24 Dec 2007 14:06:10 GMT) Full text and rfc822 format available.

Changed Bug title to `octave3.0: poissinv error' from `octave2.9: poissinv error'. Request was from Rafael Laboissiere <rafael@debian.org> to control@bugs.debian.org. (Mon, 24 Dec 2007 15:15:07 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Octave Group <pkg-octave-devel@lists.alioth.debian.org>:
Bug#418158; Package octave3.0. Full text and rfc822 format available.

Acknowledgement sent to Thomas Weber <thomas.weber.mail@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Octave Group <pkg-octave-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #31 received at 418158@bugs.debian.org (full text, mbox):

From: Thomas Weber <thomas.weber.mail@gmail.com>
To: Francesco Potorti` <Potorti@isti.cnr.it>, 418158@bugs.debian.org
Subject: Re: [Pkg-octave-devel] Bug#418158: octave2.9: poissinv error
Date: Sat, 29 Dec 2007 15:19:29 +0100
Am Samstag, den 07.04.2007, 14:42 +0200 schrieb Francesco Potorti`:
> Package: octave2.9
> Version: 2.9.9-8etch1
> Severity: normal
> 
> octave:70> poisscdf(10,10)
> ans =  0.58304
> octave:71> poissinv(10,10)
> ans = NaN
> 
> The above should be an error.  

Housekeeping:
Is my understanding correct that the above is actually correct and the
remaining error is the problem below? See also the linked discussion on
the bug@octave mailingllist.

> Additionally, poisscdf(x,x) works for
> x=100, but does not for x=1000:
> 
> octave:72> poisscdf(1000,1000)
>  ***MESSAGE FROM ROUTINE D9LGIT IN LIBRARY SLATEC.
>  ***FATAL ERROR, PROG ABORTED, TRACEBACK REQUESTED
>  *  NO CONVERGENCE IN 200 TERMS OF CONTINUED FRACTION
>  *  ERROR NUMBER = 3
>  *   
>  ***END OF MESSAGE
>  
>  ***JOB ABORT DUE TO FATAL ERROR.
> 0          ERROR MESSAGE SUMMARY
>  LIBRARY    SUBROUTINE MESSAGE START             NERR     LEVEL     COUNT
>  SLATEC     D9LGIT     NO CONVERGENCE IN 20         3         2         1
> 
> error: exception encountered in Fortran subroutine xgammainc_
> error: in /usr/share/octave/2.9.9/m/statistics/distributions/poisscdf.m near line 58, column 14:

Thanks
	Thomas





Information forwarded to debian-bugs-dist@lists.debian.org, Debian Octave Group <pkg-octave-devel@lists.alioth.debian.org>:
Bug#418158; Package octave3.0. Full text and rfc822 format available.

Acknowledgement sent to Thomas Weber <thomas.weber.mail@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Octave Group <pkg-octave-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #36 received at 418158@bugs.debian.org (full text, mbox):

From: Thomas Weber <thomas.weber.mail@gmail.com>
To: 418158@bugs.debian.org
Cc: control <control@bugs.debian.org>
Subject: Re: [Pkg-octave-devel] Bug#418158: Bug#418158: octave2.9: poissinv error
Date: Tue, 08 Jan 2008 08:45:26 +0100
package octave2.9
retitle 418158 poisscdf fails for large arguments due to the algorithm in D9LGIT
tags 418158 upstream wontfix
thanks

Francesco confirmed in a private mail that the only remaining problem is
indeed with the poisscdf call. He received a private mail by someone
suggesting that the problem is with the algorithm in D9LGIT.

I'm tagging this bug "wontfix", although "cantfix" probably describes
the situation better: the best solution would be to use a different
implementation for poisscdf(), if its arguments are large, but I don't
think we in Debian have the knowledge for this. 

Octave's upstream is likely to accept a patch for this, so feel
encouraged to submit one.

	Thomas





Changed Bug title to `poisscdf fails for large arguments due to the algorithm in D9LGIT' from `octave3.0: poissinv error'. Request was from Thomas Weber <thomas.weber.mail@gmail.com> to control@bugs.debian.org. (Tue, 08 Jan 2008 08:15:17 GMT) Full text and rfc822 format available.

Tags added: upstream, wontfix Request was from Thomas Weber <thomas.weber.mail@gmail.com> to control@bugs.debian.org. (Tue, 08 Jan 2008 08:15:18 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Octave Group <pkg-octave-devel@lists.alioth.debian.org>:
Bug#418158; Package octave3.0. Full text and rfc822 format available.

Acknowledgement sent to Ólafur Jens Sigurðsson <ojsbug@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Octave Group <pkg-octave-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #45 received at 418158@bugs.debian.org (full text, mbox):

From: Ólafur Jens Sigurðsson <ojsbug@gmail.com>
To: 418158@bugs.debian.org
Subject: more info
Date: Sun, 24 Feb 2008 12:34:01 +0100
Hi

I just tried some values and the limit seems to be poisscdf(604,604),
after that the function fails, that is poisscdf(605,605) fails and
poisscdf(604,604) succeeds.

Cheers

Oli




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Octave Group <pkg-octave-devel@lists.alioth.debian.org>:
Bug#418158; Package octave3.0. Full text and rfc822 format available.

Acknowledgement sent to Rafael Laboissiere <rafael@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Octave Group <pkg-octave-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #50 received at 418158@bugs.debian.org (full text, mbox):

From: Rafael Laboissiere <rafael@debian.org>
To: 418158@bugs.debian.org
Subject: Re: [Pkg-octave-devel] Bug#418158: more info
Date: Sun, 24 Feb 2008 18:23:30 +0100
[Message part 1 (text/plain, inline)]
* Ólafur Jens Sigurðsson <ojsbug@gmail.com> [2008-02-24 12:34]:

> I just tried some values and the limit seems to be poisscdf(604,604),
> after that the function fails, that is poisscdf(605,605) fails and
> poisscdf(604,604) succeeds.

It fails for smaller values than that, like poisscdf (599, 600).  The
culprit is the gammainc function, which ultimately calls the function
defined in d9lgit.f.

I ran the following to discover the "real" limits :

    X = [500 : 650];
    A = [500 : 650];
    nX = length (X);
    nA = length (A);
    fail = sparse (nX, nA);
    for i = 1 : nX
      for j = 1 : nA
        try
          gammainc (X (i), A (j));
        catch
          fail (i, j) = 1;
        end_try_catch
      endfor
    endfor
    [i, j] = spfind (fail);
    [(X (i)); (A(j))]'

The result is attached below.  It seems that gammainc does not like
arguments X and A close to each other, but this happens only for X and A
starting at 600.  For instance, poisscdf (599, 599) and poisscdf (1000,
1010) work fine.

I tried trivial patches as the one below, but this only pushes the limits to
higher values.

--- octave3.0-3.0.0.orig/libcruft/slatec-fn/d9lgit.f
+++ octave3.0-3.0.0/libcruft/slatec-fn/d9lgit.f
@@ -46,7 +46,7 @@
       R = 0.D0
       P = 1.D0
       S = P
-      DO 20 K=1,200
+      DO 20 K=1,1000
         FK = K
         T = (A+FK)*X*(1.D0+R)
         R = T/((AX+FK)*(A1X+FK)-T)
@@ -55,7 +55,7 @@
         IF (ABS(P).LT.EPS*S) GO TO 30
  20   CONTINUE
       CALL XERMSG ('SLATEC', 'D9LGIT',
-     +   'NO CONVERGENCE IN 200 TERMS OF CONTINUED FRACTION', 3, 2)
+     +   'NO CONVERGENCE IN 1000 TERMS OF CONTINUED FRACTION', 3, 2)
 C
  30   HSTAR = 1.0D0 - X*S/A1X
       IF (HSTAR .LT. SQEPS) CALL XERMSG ('SLATEC', 'D9LGIT',
       

-- 
Rafael
[gammainc-failures.txt (text/plain, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Octave Group <pkg-octave-devel@lists.alioth.debian.org>:
Bug#418158; Package octave3.0. Full text and rfc822 format available.

Acknowledgement sent to Rafael Laboissiere <rafael@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Octave Group <pkg-octave-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #55 received at 418158@bugs.debian.org (full text, mbox):

From: Rafael Laboissiere <rafael@debian.org>
To: 418158@bugs.debian.org
Cc: "John W. Eaton" <jwe@bevo.che.wisc.edu>
Subject: Re: [Pkg-octave-devel] Bug#418158: Bug#418158: more info
Date: Fri, 29 Feb 2008 23:46:52 +0100
* Rafael Laboissiere <rafael@debian.org> [2008-02-24 18:23]:

> * Ólafur Jens Sigurðsson <ojsbug@gmail.com> [2008-02-24 12:34]:
> 
> > I just tried some values and the limit seems to be poisscdf(604,604),
> > after that the function fails, that is poisscdf(605,605) fails and
> > poisscdf(604,604) succeeds.
> 
> It fails for smaller values than that, like poisscdf (599, 600).  The
> culprit is the gammainc function, which ultimately calls the function
> defined in d9lgit.f.

Just for the record, the gamma_inc_P function in the gsl octave-forge
package works fine in the range for which gammainc from d9lgit.f fails.  For
instance:

    octave:1> gamma_inc_P (1e5,1e5)
    ans =  0.50042

John, is there any chance of integrating GSL directly in Octave?  At least
making the compilation in files like gammainc.cc conditional on the presence
of libgsl and, if not, falling back to Slatec.
    
-- 
Rafael




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Octave Group <pkg-octave-devel@lists.alioth.debian.org>:
Bug#418158; Package octave3.0. Full text and rfc822 format available.

Acknowledgement sent to "John W. Eaton" <jwe@bevo.che.wisc.edu>:
Extra info received and forwarded to list. Copy sent to Debian Octave Group <pkg-octave-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #60 received at 418158@bugs.debian.org (full text, mbox):

From: "John W. Eaton" <jwe@bevo.che.wisc.edu>
To: Rafael Laboissiere <rafael@debian.org>, 418158@bugs.debian.org
Cc: "John W. Eaton" <jwe@bevo.che.wisc.edu>
Subject: [Pkg-octave-devel] Bug#418158: Bug#418158: Bug#418158: more info
Date: Mon, 03 Mar 2008 13:14:59 -0500
On 29-Feb-2008, Rafael Laboissiere wrote:

| * Rafael Laboissiere <rafael@debian.org> [2008-02-24 18:23]:
| 
| > * Ólafur Jens Sigurðsson <ojsbug@gmail.com> [2008-02-24 12:34]:
| > 
| > > I just tried some values and the limit seems to be poisscdf(604,604),
| > > after that the function fails, that is poisscdf(605,605) fails and
| > > poisscdf(604,604) succeeds.
| > 
| > It fails for smaller values than that, like poisscdf (599, 600).  The
| > culprit is the gammainc function, which ultimately calls the function
| > defined in d9lgit.f.
| 
| Just for the record, the gamma_inc_P function in the gsl octave-forge
| package works fine in the range for which gammainc from d9lgit.f fails.  For
| instance:
| 
|     octave:1> gamma_inc_P (1e5,1e5)
|     ans =  0.50042
| 
| John, is there any chance of integrating GSL directly in Octave?  At least
| making the compilation in files like gammainc.cc conditional on the presence
| of libgsl and, if not, falling back to Slatec.

Yes, but maybe not until after 3.1 is released unless someone shows up
with a patch.

jwe




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Octave Group <pkg-octave-devel@lists.alioth.debian.org>:
Bug#418158; Package octave3.0. Full text and rfc822 format available.

Acknowledgement sent to Rafael Laboissiere <rafael@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Octave Group <pkg-octave-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #65 received at 418158@bugs.debian.org (full text, mbox):

From: Rafael Laboissiere <rafael@debian.org>
To: control@bugs.debian.org
Cc: Sébastien Villemot <sebastien.villemot@ens.fr>, 493869@bugs.debian.org, 418158@bugs.debian.org
Subject: Re: Bug#493869: octave3.0: gaminv and gamcdf crash for big values of parameter A
Date: Tue, 5 Aug 2008 21:41:24 +0200
package octave3.0
tags 493869 upstream wontfix
forwarded 493869 http://www.cae.wisc.edu/pipermail/bug-octave/2007-April/002103.html
merge 493869 418158
thanks

* Sébastien Villemot <sebastien.villemot@ens.fr> [2008-08-05 16:47]:

> "Thomas Weber" <thomas.weber.mail@gmail.com> a écrit :
> > See
> > http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=418158
> >
> > d9lgit.f needs an improvement, either directly or by completely
> > replacing it with something better.
> 
> Thanks for pointing me to this bug report. I hadn't noticed that the  
> bug in poisscdf() was indeed caused by the same problem in gammainc(),  
> itself caused by a problem in d9lgit.

I am hereby merging the two bug reports.

-- 
Rafael




Merged 418158 493869. Request was from Rafael Laboissiere <rafael@debian.org> to control@bugs.debian.org. (Tue, 05 Aug 2008 19:42:10 GMT) Full text and rfc822 format available.

Bug reassigned from package 'octave3.0' to 'octave3.2'. Request was from Thomas Weber <thomas.weber.mail@gmail.com> to control@bugs.debian.org. (Sat, 27 Mar 2010 11:51:07 GMT) Full text and rfc822 format available.

Bug No longer marked as found in versions octave3.0/1:3.0.1-6 and octave3.0/3.0.0-1. Request was from Thomas Weber <thomas.weber.mail@gmail.com> to control@bugs.debian.org. (Sat, 27 Mar 2010 11:51:08 GMT) Full text and rfc822 format available.

Bug reassigned from package 'octave3.2' to 'octave'. Request was from Sébastien Villemot <sebastien.villemot@ens.fr> to control@bugs.debian.org. (Wed, 04 Apr 2012 19:21:08 GMT) Full text and rfc822 format available.

Marked as found in versions octave/3.6.1-4. Request was from Sébastien Villemot <sebastien.villemot@ens.fr> to control@bugs.debian.org. (Wed, 04 Apr 2012 19:21:09 GMT) Full text and rfc822 format available.

Changed Bug forwarded-to-address to 'https://mailman.cae.wisc.edu/pipermail/bug-octave/2007-May/008795.html' from 'http://www.cae.wisc.edu/pipermail/bug-octave/2007-April/002103.html' Request was from Sébastien Villemot <sebastien.villemot@ens.fr> to control@bugs.debian.org. (Wed, 04 Apr 2012 19:42:04 GMT) Full text and rfc822 format available.

Changed Bug forwarded-to-address to 'https://mailman.cae.wisc.edu/pipermail/bug-octave/2007-April/008582.html' from 'https://mailman.cae.wisc.edu/pipermail/bug-octave/2007-May/008795.html' Request was from Sébastien Villemot <sebastien.villemot@ens.fr> to control@bugs.debian.org. (Wed, 04 Apr 2012 19:42:07 GMT) Full text and rfc822 format available.

Changed Bug forwarded-to-address to 'https://savannah.gnu.org/bugs/index.php?39309' from 'https://mailman.cae.wisc.edu/pipermail/bug-octave/2007-April/008582.html' Request was from Thomas Weber <tweber@debian.org> to control@bugs.debian.org. (Fri, 21 Jun 2013 11:33:04 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 17 06:51:44 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.